Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QRegion

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.gui.QRegion

All Implemented Interfaces:
  QtJambiInterface, java.lang.Cloneable

    public class QRegion

extends QtJambiObject
implements java.lang.Cloneable

The `QRegion` class specifies a clip region for a painter. `QRegion` is used with `QPainter::setClipRegion()` to limit the paint area to what needs to be painted. There is also a `QWidget::repaint()` function that takes a `QRegion` parameter. `QRegion` is the best tool for reducing flicker.

A region can be created from a rectangle, an ellipse, a polygon or a bitmap. Complex regions may be created by combining simple regions using `united()`, `intersected()`, `subtracted()`, or `xored()` (exclusive or). You can move a region using `translate()`.

You can test whether a region `isEmpty()` or if it `contains()` a `QPoint` or `QRect`. The bounding rectangle can be found with `boundingRect()`.

The function `rects()` gives a decomposition of the region into rectangles.

Example of using complex regions:

        protected void paintEvent(QPaintEvent e) {
            // r1: elliptic region
            QRegion r1 = new QRegion(new QRect(100, 100, 200, 80),
                                     QRegion.RegionType.Ellipse);

            // r2: rectangular region
            QRegion r2 = new QRegion(new QRect(100, 120, 90, 30));

            // r3: intersection
            QRegion r3 = r1.intersected(r2);

            QPainter painter = new QPainter(this);
            painter.setClipRegion(r3);

            // paint clipped graphics
        }

`QRegion` is an implicitly shared class.

Warning: Due to window system limitations, the whole coordinate space for a region is limited to the points between -32767 and 32767 on Windows 95/98/ME. You can circumvent this limitation by using a `QPainterPath`.

## Additional License Information

On Embedded Linux, Windows CE and X11 platforms, parts of this class rely on code obtained under the following license:Copyright (c) 1987 X ConsortiumPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.Except as contained in this notice, the name of the X Consortium shall not be used in advertising or otherwise to promote the sale, use or other dealings in this Software without prior written authorization from the X Consortium.

Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts.All Rights ReservedPermission to use, copy, modify, and distribute this software and its documentation for any purpose and without fee is hereby granted, provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice appear in supporting documentation, and that the name of Digital not be used in advertising or publicity pertaining to distribution of the software without specific, written prior permission.DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

See also:
  `QPainter::setClipRegion()`, `QPainter::setClipRect()`, and `QPainterPath`.

Nested Class Summary
`static class` | `QRegion.RegionType` Specifies the shape of the region to be created.

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QRegion()` Constructs an empty region.
`QRegion(int x, int y, int w, int h)` Constructs a rectangular or elliptic region.
`QRegion(int x, int y, int w, int h, QRegion.RegionType t)` Constructs a rectangular or elliptic region.
`QRegion(QBitmap bitmap)` Constructs a region from the bitmap `bm`.
`QRegion(QPolygon pa)` Constructs a polygon region from the point array `a` with the fill rule specified by `fillRule`.
`QRegion(QPolygon pa, Qt.FillRule fillRule)` Constructs a polygon region from the point array `a` with the fill rule specified by `fillRule`.
`QRegion(QRect r)` Create a region based on the rectange `r` with region type `t`.
`QRegion(QRect r, QRegion.RegionType t)` Create a region based on the rectange `r` with region type `t`.
`QRegion(QRegion region)` Constructs a new region which is equal to region `r`.

Method Summary
`QRect` | `boundingRect()` Returns the bounding rectangle of this region.
`QRegion` | `clone()` This method is reimplemented for internal reasons
`boolean` | `contains(QPoint p)` Returns true if the region contains the point `p`; otherwise returns false.
`boolean` | `contains(QRect r)` Returns true if the region overlaps the rectangle `r`; otherwise returns false.
`QRegion` | `intersect(QRect r)` Use intersected(`rect`) instead.
`QRegion` | `intersected(QRect r)` Returns a region which is the intersection of this region and the given `rect`.
`QRegion` | `intersected(QRegion r)` Returns a region which is the intersection of this region and `r`.
`boolean` | `intersects(QRect r)` Returns true if this region intersects with `rect`, otherwise returns false.
`boolean` | `intersects(QRegion r)` Returns true if this region intersects with `region`, otherwise returns false.
`boolean` | `isEmpty()` Returns true if the region is empty; otherwise returns false.
`int` | `numRects()` Returns the number of rectangles that will be returned in `rects()`.
`QRegion` | `operator_add(QRect r)`
`void` | `readFrom(QDataStream arg__1)` Reads a QRegion
`java.util.List` | `rects()` Returns an array of non-overlapping rectangles that make up the region.
`void` | `setRects(QRect[] rects)` Sets the region using the array of rectangles specified by `rects` and `number`.
`QRegion` | `subtracted(QRegion r)` Returns a region which is `r` subtracted from this region.
`java.lang.String` | `toString()` Returns a string representation of the `this QRegion`.
`void` | `translate(int dx, int dy)` Translates (moves) the region `dx` along the X axis and `dy` along the Y axis.
`void` | `translate(QPoint p)` Translates the region `point`.x() along the x axis and `point`.y() along the y axis, relative to the current position.
`QRegion` | `translated(int dx, int dy)` Returns a copy of the region that is translated `dx` along the x axis and `dy` along the y axis, relative to the current position.
`QRegion` | `translated(QPoint p)` Returns a copy of the regtion that is translated `p`.
`QRegion` | `unite(QRect r)` Use united(`rect`) instead.
`QRegion` | `united(QRect r)` Returns a region which is the union of this region and the given `rect`.
`QRegion` | `united(QRegion r)` Returns a region which is the union of this region and `r`.
`void` | `writeTo(QDataStream arg__1)` Writes thisQRegion
`QRegion` | `xored(QRegion r)` Returns a region which is the exclusive or (XOR) of this region and `r`.

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QRegion

    public QRegion()

  Constructs an empty region.

See also:
  `isEmpty()`.

### QRegion

    public QRegion(QBitmap bitmap)

  Constructs a region from the bitmap `bm`.

  The resulting region consists of the pixels in bitmap `bm` that are `Qt::color1` , as if each pixel was a 1 by 1 rectangle.

  This constructor may create complex regions that will slow down painting when used. Note that drawing masked pixmaps can be done much faster using `QPixmap::setMask()`.

### QRegion

    public QRegion(QPolygon pa)

  Constructs a polygon region from the point array `a` with the fill rule specified by `fillRule`.

  If `fillRule` is `Qt::WindingFill` , the polygon region is defined using the winding algorithm; if it is `Qt::OddEvenFill` , the odd-even fill algorithm is used.

  Warning: This constructor can be used to create complex regions that will slow down painting when used.

### QRegion

    public QRegion(QPolygon pa,
                   Qt.FillRule fillRule)

  Constructs a polygon region from the point array `a` with the fill rule specified by `fillRule`.

  If `fillRule` is `Qt::WindingFill` , the polygon region is defined using the winding algorithm; if it is `Qt::OddEvenFill` , the odd-even fill algorithm is used.

  Warning: This constructor can be used to create complex regions that will slow down painting when used.

### QRegion

    public QRegion(QRect r)

  Create a region based on the rectange `r` with region type `t`.

  If the rectangle is invalid a null region will be created.

See also:
  `QRegion::RegionType` .

### QRegion

    public QRegion(QRect r,
                   QRegion.RegionType t)

  Create a region based on the rectange `r` with region type `t`.

  If the rectangle is invalid a null region will be created.

See also:
  `QRegion::RegionType` .

### QRegion

    public QRegion(QRegion region)

  Constructs a new region which is equal to region `r`.

### QRegion

    public QRegion(int x,
                   int y,
                   int w,
                   int h)

  Constructs a rectangular or elliptic region.

  If `t` is `Rectangle`, the region is the filled rectangle (`x`, `y`, `w`, `h`). If `t` is `Ellipse`, the region is the filled ellipse with center at (`x` + `w` / 2, `y` + `h` / 2) and size (`w` ,`h`).

### QRegion

    public QRegion(int x,
                   int y,
                   int w,
                   int h,
                   QRegion.RegionType t)

  Constructs a rectangular or elliptic region.

  If `t` is `Rectangle`, the region is the filled rectangle (`x`, `y`, `w`, `h`). If `t` is `Ellipse`, the region is the filled ellipse with center at (`x` + `w` / 2, `y` + `h` / 2) and size (`w` ,`h`).

Method Detail

### boundingRect

    public final QRect boundingRect()

  Returns the bounding rectangle of this region. An empty region gives a rectangle that is `QRect::isNull()`.

### contains

    public final boolean contains(QPoint p)

  Returns true if the region contains the point `p`; otherwise returns false.

### contains

    public final boolean contains(QRect r)

  Returns true if the region overlaps the rectangle `r`; otherwise returns false.

### intersect

    public final QRegion intersect(QRect r)

  Use intersected(`rect`) instead.

### intersected

    public final QRegion intersected(QRect r)

  Returns a region which is the intersection of this region and the given `rect`.

See also:
  `subtracted()`, `united()`, and `xored()`.

### intersected

    public final QRegion intersected(QRegion r)

  Returns a region which is the intersection of this region and `r`.
  The figure shows the intersection of two elliptical regions.

See also:
  `subtracted()`, `united()`, and `xored()`.

### intersects

    public final boolean intersects(QRect r)

  Returns true if this region intersects with `rect`, otherwise returns false.

### intersects

    public final boolean intersects(QRegion r)

  Returns true if this region intersects with `region`, otherwise returns false.

### isEmpty

    public final boolean isEmpty()

  Returns true if the region is empty; otherwise returns false. An empty region is a region that contains no points.

  Example:

              QRegion r1 = new QRegion(10, 10, 20, 20);
              r1.isEmpty();               // false

              QRegion r2 = new QRegion(40, 40, 20, 20);
              QRegion r3 = new QRegion();
              r3.isEmpty();               // true

              r3 = r1.intersected(r2);    // r3: intersection of r1 and r2
              r3.isEmpty();               // true

              r3 = r1.united(r2);         // r3: union of r1 and r2
              r3.isEmpty();               // false

### numRects

    public final int numRects()

  Returns the number of rectangles that will be returned in `rects()`.

### operator_add

    public final QRegion operator_add(QRect r)

### writeTo

    public final void writeTo(QDataStream arg__1)

  Writes thisQRegion

### readFrom

    public final void readFrom(QDataStream arg__1)

  Reads a QRegion

### rects

    public final java.util.List rects()

  Returns an array of non-overlapping rectangles that make up the region.

  The union of all the rectangles is equal to the original region.

See also:
  `setRects()`.

### subtracted

    public final QRegion subtracted(QRegion r)

  Returns a region which is `r` subtracted from this region.
  The figure shows the result when the ellipse on the right is subtracted from the ellipse on the left (`left - right`).

See also:
  `intersected()`, `united()`, and `xored()`.

### translate

    public final void translate(QPoint p)

  Translates the region `point`.x() along the x axis and `point`.y() along the y axis, relative to the current position. Positive values move the region to the right and down.

  Translates to the given `point`.

### translate

    public final void translate(int dx,
                                int dy)

  Translates (moves) the region `dx` along the X axis and `dy` along the Y axis.

### translated

    public final QRegion translated(QPoint p)

  Returns a copy of the regtion that is translated `p`. () along the x axis and `p`.y() along the y axis, relative to the current position. Positive values move the rectangle to the right and down.

See also:
  `translate()`.

### translated

    public final QRegion translated(int dx,
                                    int dy)

  Returns a copy of the region that is translated `dx` along the x axis and `dy` along the y axis, relative to the current position. Positive values move the region to the right and down.

See also:
  `translate()`.

### unite

    public final QRegion unite(QRect r)

  Use united(`rect`) instead.

### united

    public final QRegion united(QRect r)

  Returns a region which is the union of this region and the given `rect`.

See also:
  `intersected()`, `subtracted()`, and `xored()`.

### united

    public final QRegion united(QRegion r)

  Returns a region which is the union of this region and `r`.
  The figure shows the union of two elliptical regions.

See also:
  `intersected()`, `subtracted()`, and `xored()`.

### xored

    public final QRegion xored(QRegion r)

  Returns a region which is the exclusive or (XOR) of this region and `r`.
  The figure shows the exclusive or of two elliptical regions.

See also:
  `intersected()`, `united()`, and `subtracted()`.

### setRects

    public void setRects(QRect[] rects)

  Sets the region using the array of rectangles specified by `rects` and `number`. The rectangles must be optimally Y-X sorted and follow these restrictions:
  - The rectangles must not intersect.
  - All rectangles with a given top coordinate must have the same height.
  - No two rectangles may abut horizontally (they should be combined into a single wider rectangle in that case).
  - The rectangles must be sorted in ascending order, with Y as the major sort key and X as the minor sort key.

See also:
  `rects()`.

### toString

    public java.lang.String toString()

  Returns a string representation of the `this QRegion`.

  Overrides:
    `toString` in class `java.lang.Object`

### clone

    public QRegion clone()

  This method is reimplemented for internal reasons

  Overrides:
    `clone` in class `java.lang.Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD